#include-once
;******************************************************************************
;***            EzBmpButton
;***                  by Greenhorn
;***
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>

Global $gdi32dll		=	DllOpen ("gdi32.dll")
Global $user32dll		=	DllOpen ("user32.dll")
Global $shell32dll		=	DllOpen ("shell32.dll")
Global $kernel32dll		=	DllOpen ("kernel32.dll")
;~~~~~~~~~~~~~~~~~~~~~~  Structures  ~~~~~~~~~~~~~~~~~~~~~~
#Region Structures

; --- $CREATESTRUCT
Global Const $CREATESTRUCT = _
	"ptr   lpCreateParams;"& _
	"ptr   hInstance;"& _
	"ptr   hMenu;"& _
	"hwnd  hwndParent;"& _
	"int   cy;"& _
	"int   cx;"& _
	"int   y;"& _
	"int   x;"& _
	"long  style;"& _
	"ptr   lpszName;"& _
	"ptr   lpszClass;"& _
	"dword dwExStyle;"


Global Const $WNDCLASSEX = _
	"uint cbSize;" & _
	"uint style;" & _
	"ptr  lpfnWndProc;" & _
	"int  cbClsExtra;" & _
	"int  cbWndExtra;" & _
	"ptr  hInstance;" & _
	"ptr  hIcon;" & _
	"ptr  hCursor;" & _
	"ptr  hbrBackground;" & _
	"ptr  lpszMenuName;" & _
	"ptr  lpszClassName;" & _
	"ptr  hIconSm;"
;
Global Const $POINT = _
	"long x;" & _
	"long y;"
;
Global Const $RECT = _
	"long left;" & _
	"long top;" & _
	"long right;" & _
	"long bottom;"
;
Global Const $SIZE = _
    'long  cx;'& _
    'long  cy;'

Global Const $PAINTSTRUCT = _
	"hwnd hDC;" & _
	"int  fErase;" & _
	"long rcPaint[4];" & _
	"int  fRestore;" & _
	"int  fIncUpdate;" & _
	"byte rgbReserved[32]"

Global Const $MSG = _
	"hwnd hwnd;" & _
	"uint message;" & _
	"uint wParam;" & _
	"long lParam;" & _
	"dword time;" & _
	$POINT

; --- $TRACKMOUSEEVENT
Global Const $TRACKMOUSEEVENT = _
	'dword cbSize;'& _
	'dword dwFlags;'& _
	'hwnd  hwndTrack;'& _
	'dword dwHoverTime;'

; --- $NMHDR
Global Const $NMHDR = _
		'hwnd     hwndFrom;'& _
		'uint_ptr idFrom;'& _
		'uint     code;'

; --- $NMBCHOTITEM
Global Const $NMBCHOTITEM = _
		$NMHDR& _
		'dword dwFlags;'

; --- $BITMAP
Global Const $BITMAP = _
		'long   bmType;'& _
		'long   bmWidth;'& _
		'long   bmHeight;'& _
		'long   bmWidthBytes;'& _
		'ushort bmPlanes;'& _
		'ushort bmBitsPixel;'& _
		'ptr    bmBits;'


;	Custom Control state structure:
Global Const $BUTTONCTRL = _
    "ptr      hBmpNormal;"& _   ; bitmap in normal state
    "ptr      hBmpHover;"& _    ; bitmap in mouse hovering state
    "ptr      hBmpPress;"& _    ; bitmap in mouse pressed state
    "ptr      hBmpCurrent;"& _  ; bitmap to display currently
    "ptr      hdcMem;"& _       ; private DC
	"dword    colorText;"& _    ; Text Foreground text colour
    "ptr      hFont;"& _        ; The font
    "hwnd     hWndCtrl;"        ; The control"s window handle

#EndRegion Structures

;~~~~~~~~~~~~~~~~~~~~~~  Constants  ~~~~~~~~~~~~~~~~~~~~~~

#Region Constants

Global Const $_NULL = Ptr (0)

Global Const $WM_LBUTTONDOWN = 0x0201
Global Const $WM_MOUSEHOVER  = 0x02A1
Global Const $WM_MOUSELEAVE  = 0x02A3

Global Const $_CS_VREDRAW = 0x0001
Global Const $_CS_HREDRAW = 0x0002

Global Const $_IDI_APPLICATION = 32512
Global Const $_IDC_ARROW = MAKEINTRESOURCE (32512)

Global Const $_WHITE_BRUSH         = 0
Global Const $_LTGRAY_BRUSH        = 1
Global Const $_GRAY_BRUSH          = 2
Global Const $_DKGRAY_BRUSH        = 3
Global Const $_BLACK_BRUSH         = 4
Global Const $_NULL_BRUSH          = 5
Global Const $_HOLLOW_BRUSH        = 5
Global Const $_WHITE_PEN           = 6
Global Const $_BLACK_PEN           = 7
Global Const $_NULL_PEN            = 8
Global Const $_SYSTEM_FONT         = 13
Global Const $_DEFAULT_PALETTE     = 15
Global Const $_ANSI_FIXED_FONT     = 11
Global Const $_ANSI_VAR_FONT       = 12
Global Const $_DEVICE_DEFAULT_FONT = 14
Global Const $_DEFAULT_GUI_FONT    = 17
Global Const $_OEM_FIXED_FONT      = 10
Global Const $_SYSTEM_FIXED_FONT   = 16

Global Const $_ETO_OPAQUE = 0x0002

Global Const $_TME_HOVER	= 1
Global Const $_TME_LEAVE	= 2
Global Const $_TME_QUERY	= 0x40000000
Global Const $_TME_CANCEL	= 0x80000000
Global Const $_HOVER_DEFAULT	= 0xFFFFFFFF

Global Const $_VK_RETURN	= 13
Global Const $_VK_SPACE	= 32
Global Const $_VK_TAB	= 9

Global Const $_IMAGE_BITMAP = 0
Global Const $_IMAGE_ICON	= 1
Global Const $_IMAGE_CURSOR	= 2
Global Const $_IMAGE_ENHMETAFILE	= 3

Global Const $_LR_DEFAULTCOLOR = 0
Global Const $_LR_MONOCHROME = 1
Global Const $_LR_COLOR = 2
Global Const $_LR_COPYRETURNORG = 4
Global Const $_LR_COPYDELETEORG = 8
Global Const $_LR_LOADFROMFILE = 16
Global Const $_LR_LOADTRANSPARENT = 32
Global Const $_LR_LOADREALSIZE = 128
Global Const $_LR_DEFAULTSIZE = 0x0040
Global Const $_LR_VGACOLOR = 0x0080
Global Const $_LR_LOADMAP3DCOLORS = 4096
Global Const $_LR_CREATEDIBSECTION = 8192
Global Const $_LR_COPYFROMRESOURCE = 0x4000
Global Const $_LR_SHARED = 32768

Global Const $_BM_CLICK = 245
Global Const $_BM_GETCHECK = 240
Global Const $_BM_GETIMAGE = 246
Global Const $_BM_GETSTATE = 242
Global Const $_BM_SETCHECK = 241
Global Const $_BM_SETIMAGE = 247
Global Const $_BM_SETSTATE = 243
Global Const $_BM_SETSTYLE = 244
Global Const $_BN_CLICKED = 0
Global Const $_BN_DBLCLK = 5
Global Const $_BN_DISABLE = 4
Global Const $_BN_DOUBLECLICKED = 5
Global Const $_BN_HILITE = 2
Global Const $_BN_KILLFOCUS = 7
Global Const $_BN_PAINT = 1
Global Const $_BN_PUSHED = 2
Global Const $_BN_SETFOCUS = 6
Global Const $_BN_UNHILITE = 3
Global Const $_BN_UNPUSHED = 3


#EndRegion Constants
;


Global Const $g_sBtnClassName = "EzBmpButton"

Global Const $g_hInst = GetModuleHandle ($_NULL)

Global $g_astButton [1] = [$_NULL]

Global $g_hButtonProc = DllCallbackRegister ("EzBmpButtonProc", "long", "hwnd;uint;wparam;lparam")

InitEzButtonClass ( )


Func CreateEzBmpButton ($sTitle, $left, $top, $width, $height, $hWndParent, $bmpDefault, $bmpHover, $bmpPress, $colorText = 0)
	
	Local $hwnd
	Local $lpBitmaps
	Local $stBitmaps
	
	; A dirty solution, I think, but it works ...
	$ctrlID = GUICtrlCreateDummy ( )
	
	; We could also load here the bitmaps and just put the
	; Handles into the structure, but I prefer to load them
	; at window creation. So we just put the path or resource ID
	; into the structure and set a pointer to this structure
	; at the lpParam to get the information back in the window's procedure.
	
	$stBitmaps = DllStructCreate ("char  bmpDefault [260];"& _
								  "char  bmpHover   [260];"& _
								  "char  bmpPress   [260];"& _
								  "dword colTxt")

	DllStructSetData ($stBitmaps, "bmpDefault", $bmpDefault)
	DllStructSetData ($stBitmaps, "bmpHover"  , $bmpHover)
	DllStructSetData ($stBitmaps, "bmpPress"  , $bmpPress)
	DllStructSetData ($stBitmaps, "colTxt"    , $colorText)
	
	$lpBitmaps = DllStructGetPtr ($stBitmaps)
	
	$hwnd = CreateWindowEx ( _
				0x2000000, _
				$g_sBtnClassName, _
				$sTitle, _
				BitOR ($WS_CHILD, $WS_VISIBLE, $WS_TABSTOP, $WS_CLIPSIBLINGS), _
				$left, $top, $width, $height, _
				$hWndParent, _
				$ctrlID, _
				$g_hInst, _
				$lpBitmaps)
	
	Return $ctrlID
	
EndFunc

Func InitEzButtonClass ( )
	
	Local $szBtnClassName, $wcx, $lpwcx
	
	$szBtnClassName = DllStructCreate ("char szBtnClassName [12]")
	DllStructSetData ($szBtnClassName, "szBtnClassName", $g_sBtnClassName)
	
	$wcx = DllStructCreate ($WNDCLASSEX)
	
	DllStructSetData ($wcx,"cbSize",        DllStructGetSize ($wcx))
	DllStructSetData ($wcx,"style",         BitOR ($_CS_HREDRAW, $_CS_VREDRAW))
	DllStructSetData ($wcx,"lpfnWndProc",   DllCallbackGetPtr ($g_hButtonProc))
	DllStructSetData ($wcx,"cbClsExtra",    0)
	DllStructSetData ($wcx,"cbWndExtra",    4)   ; here we store the pointer to the ButtonCtrl structure.
	DllStructSetData ($wcx,"hInstance",     $g_hInst)
	DllStructSetData ($wcx,"hIcon",         LoadIcon ($_NULL, $_IDI_APPLICATION))
	DllStructSetData ($wcx,"hCursor",       LoadCursor ($_NULL, $_IDC_ARROW))
	DllStructSetData ($wcx,"hbrBackground", GetStockObject ($_LTGRAY_BRUSH))
	DllStructSetData ($wcx,"lpszMenuName",  $_NULL)
	DllStructSetData ($wcx,"lpszClassName", DllStructGetPtr ($szBtnClassName))
	DllStructSetData ($wcx,"hIconSm",       LoadIcon ($_NULL, $_IDI_APPLICATION))
	
	$lpwcx = DllStructGetPtr ($wcx)
	
	If Not RegisterClassEx ($lpwcx) Then
		MsgBox (266256, "Fehler!", "Die Fensterklasse konnte nicht registriert werden!")
		Exit (1)
	EndIf

EndFunc

Func EzBmpButtonProc ($hWnd, $uMsg, $wParam, $lParam)

	; Get the pointer to the button structure
	; for THIS window.
	Local $lpButton = GetWindowLong ($hWnd, 0)
	
	Switch ($uMsg)
		
		Case $WM_NCCREATE
			 OnCreate ($hWnd, $lParam)
			 Return True
			 
		Case $WM_PAINT
			 OnPaint ($lpButton)
			 
		Case $WM_ERASEBKGND
			 Return True
			 
		Case $WM_KEYUP
			 OnKeyUp ($lpButton, $wParam)
			 
		Case $WM_KEYDOWN
			 OnKeyDown ($lpButton, $wParam)
			 
		Case $WM_LBUTTONDOWN
			 OnLButtonDown ($lpButton)
			 
		Case $WM_LBUTTONUP
			 OnLButtonUp ($lpButton)
			 
		Case $WM_MOUSELEAVE
			 OnMouseLeave ($lpButton)
			 
		Case $WM_MOUSEMOVE
			 OnMouseMove ($lpButton)
			 
		Case $WM_MOUSEHOVER
			 OnMouseHover ($lpButton)
			 
		Case $WM_GETFONT
			 Return OnGetFont ($lpButton)
			 
		Case $WM_SETFONT
			 OnSetFont ($lpButton, $wParam)
			 
		Case $WM_SETFOCUS
			 OnSetFocus ($lpButton)
			 
		Case $WM_KILLFOCUS
			 OnKillFocus ($lpButton)
			 
		Case $WM_NCDESTROY
			 OnDestroy ($lpButton)
			 ContinueCase
		Case Else
			 Return DefWindowProc ($hWnd, $uMsg, $wParam, $lParam)
	EndSwitch

	Return 0

EndFunc

Func LoadButtonBitmaps (ByRef $stButtonInfo, $lpCreateParams)

	Local $stCreateParams
	Local $asBmp [3]
	Local $hBmp
	
	If (Not $lpCreateParams) Then _
		Return False
	
	$stCreateParams = DllStructCreate ("char  bmpDefault [260];"& _
									   "char  bmpHover   [260];"& _
									   "char  bmpPress   [260];"& _
									   "dword colTxt", _
									   $lpCreateParams)
	
	; first set the text color.
	DllStructSetData ($stButtonInfo, "colorText", _
			DllStructGetData ($stCreateParams, "colTxt"))
	
	$asBmp[0] = DllStructGetData ($stCreateParams, "bmpDefault")
	$asBmp[1] = DllStructGetData ($stCreateParams, "bmpHover")
	$asBmp[2] = DllStructGetData ($stCreateParams, "bmpPress")
	
	For $i = 0 To 2
		If (IS_INTRESOURCE($asBmp[$i])) Then
			
			$hBmp = LoadImage ($g_hInst, MAKEINTRESOURCE($asBmp[$i]), $_IMAGE_BITMAP, _
								0, 0, BitOR ($_LR_DEFAULTSIZE, $_LR_CREATEDIBSECTION))
			
			If (Not $hBmp) Then _
				MsgBox (266256, "Error", "LoadImage "&$asBmp[$i]&" failed!" & @crlf)
			
			DllStructSetData ($stButtonInfo, $i + 1, $hBmp)

		ElseIf (Not FileExists ($asBmp[$i])) Then
			
			$hBmp = LoadImage ($g_hInst, $asBmp[$i], $_IMAGE_BITMAP, _
								0, 0, BitOR ($_LR_DEFAULTSIZE, $_LR_CREATEDIBSECTION))
			
			If (Not $hBmp) Then _
				MsgBox (266256, "Error", "LoadImage "&$asBmp[$i]&" failed!" & @crlf)
			
			DllStructSetData ($stButtonInfo, $i + 1, $hBmp)

		Else
			
			$hBmp = LoadImage ($_NULL, $asBmp[$i], $_IMAGE_BITMAP, _
								0, 0, BitOR ($_LR_DEFAULTSIZE, $_LR_LOADFROMFILE, $_LR_CREATEDIBSECTION))
			
			If (Not $hBmp) Then _
				ConsoleWrite ("!>LoadImage failed!" & @crlf)
			
			DllStructSetData ($stButtonInfo, $i + 1, $hBmp)
		EndIf
	Next
	
	DllStructSetData ($stButtonInfo, "hBmpCurrent", DllStructGetData ($stButtonInfo, "hBmpNormal"))
	
	Return True

EndFunc

Func NotifyParent ($lpBtnInfo, $uCode)

	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Local $nmh     = DllStructCreate ($NMHDR)
	Local $hwndCtrl = DllStructGetData ($btnInfo, "hWndCtrl")

	DllStructSetData ($nmh, "code"    , $uCode)
	DllStructSetData ($nmh, "idFrom"  , GetDlgCtrlID ($hwndCtrl))
	DllStructSetData ($nmh, "hwndFrom", $hwndCtrl)
	
	SendMessage (GetParent ($hwndCtrl), _
				 $WM_NOTIFY, _
				 GetDlgCtrlID ($hwndCtrl), _
				 DllStructGetPtr ($nmh))
	
EndFunc

Func OnCreate ($hWnd, $lParam)

	Local $cs
	Local $iSize = 0
	
	$cs = DllStructCreate ($CREATESTRUCT, $lParam)

	$iSize = UBound ($g_astButton)

	If (IsDllStruct ($g_astButton[0])) Then
		ReDim $g_astButton [$iSize + 1]
		$iSize += 1
	EndIf

	$g_astButton[$iSize - 1] = DllStructCreate ($BUTTONCTRL)

	If ($g_astButton[$iSize - 1] == 0) Then _
		Return False

	DllStructSetData ($g_astButton[$iSize - 1], "hWndCtrl" , $hWnd)
	DllStructSetData ($g_astButton[$iSize - 1], "hFont", GetStockObject ($_DEFAULT_GUI_FONT))

	; Create a private DC and store it in the button structure
	DllStructSetData ($g_astButton[$iSize - 1], "hdcMem", CreateCompatibleDC (0))

	; Load the bitmaps for the window
	LoadButtonBitmaps ($g_astButton[$iSize - 1], DllStructGetData ($cs, "lpCreateParams"))

	; Assign the window text as specified in the call to CreateWindow
	SetWindowText ($hwnd, DllStructGetData ($cs, "lpszName"))

	; Attach custom structure to this window.
	SetWindowLong ($hWnd, 0, DllStructGetPtr ($g_astButton[$iSize - 1]))

EndFunc

Func OnDestroy ($lpBtnInfo)
	
	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Local $iSize = UBound ($g_astButton)

	; cleanup ...
	GUICtrlDelete (GetDlgCtrlID (DllStructGetData ($btnInfo, "hWndCtrl")))
	
	DeleteObject (DllStructGetData ($btnInfo, 'hBmpNormal'))
	DeleteObject (DllStructGetData ($btnInfo, 'hBmpHover'))
	DeleteObject (DllStructGetData ($btnInfo, 'hBmpPress'))
	
	DeleteDC (DllStructGetData ($btnInfo, 'hdcMem'))
	
	$btnInfo = 0
	
	If ($iSize > 1) Then
		ReDim $g_astButton [$iSize - 1]
	Else
		$g_astButton = 0
	EndIf

EndFunc

Func OnGetFont ($lpBtnInfo)

	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Return DllStructGetData ($btnInfo, "hFont")

EndFunc

Func OnKeyDown ($lpBtnInfo, $wParam)
	
	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Local $hwndCtrl = DllStructGetData ($btnInfo, "hWndCtrl")
	
	If ($wParam == $_VK_RETURN Or _
		$wParam == $_VK_SPACE) Then
	
		If (DllStructGetData ($btnInfo, "hBmpCurrent") <> _
			DllStructGetData ($btnInfo, "hBmpPress")) Then
			
			DllStructSetData ($btnInfo, "hBmpCurrent", _
					DllStructGetData ($btnInfo, "hBmpPress"))

			RedrawWindow ($hwndCtrl, _
						  $_NULL, _
						  $_NULL, _
						  BitOR ($RDW_ERASE, $RDW_INVALIDATE))
		EndIf
	EndIf

EndFunc

Func OnKeyUp ($lpBtnInfo, $wParam)
	
	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Local $hwndCtrl = DllStructGetData ($btnInfo, "hWndCtrl")
	
	If ($wParam == $_VK_RETURN Or _
		$wParam == $_VK_SPACE) Then
	
		DllStructSetData ($btnInfo, "hBmpCurrent", _
				DllStructGetData ($btnInfo, "hBmpHover"))

		RedrawWindow ($hwndCtrl, _
					  $_NULL, _
					  $_NULL, _
					  BitOR ($RDW_ERASE, $RDW_INVALIDATE))
		
		GUICtrlSendToDummy (GetDlgCtrlID ($hwndCtrl))
		
		NotifyParent ($lpBtnInfo, $_BN_CLICKED)
		PostMessage (GetParent ($hwndCtrl), _
					 $WM_COMMAND, _
					 MAKEWPARAM(GetDlgCtrlID ($hwndCtrl), $_BN_CLICKED), _
					 $hWndCtrl)
	EndIf

EndFunc

Func OnKillFocus ($lpBtnInfo)

	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Local $hwndCtrl = DllStructGetData ($btnInfo, "hWndCtrl")

	DllStructSetData ($btnInfo, "hBmpCurrent", DllStructGetData ($btnInfo, "hBmpNormal"))
	
	RedrawWindow ($hwndCtrl, _
				  $_NULL, _
				  $_NULL, _
				  BitOR ($RDW_ERASE, $RDW_INVALIDATE))
	
	PostMessage (GetParent ($hwndCtrl), _
				 $WM_COMMAND, _
				 MAKEWPARAM(GetDlgCtrlID ($hwndCtrl), $_BN_KILLFOCUS), _
				 $hwndCtrl)
	
EndFunc

Func OnLButtonDown ($lpBtnInfo)
	
	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Local $hwndCtrl = DllStructGetData ($btnInfo, "hWndCtrl")
	
	SetFocus ($hwndCtrl)
	
	DllStructSetData ($btnInfo, "hBmpCurrent", DllStructGetData ($btnInfo, "hBmpPress"))

	RedrawWindow ($hwndCtrl, _
				  $_NULL, _
				  $_NULL, _
				  BitOR ($RDW_ERASE, $RDW_INVALIDATE))

EndFunc

Func OnLButtonUp ($lpBtnInfo)
	
	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Local $hwndCtrl = DllStructGetData ($btnInfo, "hWndCtrl")

	If (DllStructGetData ($btnInfo, "hBmpCurrent") == _
		DllStructGetData ($btnInfo, "hBmpPress")) Then
		
		DllStructSetData ($btnInfo, "hBmpCurrent", DllStructGetData ($btnInfo, "hBmpHover"))

		RedrawWindow ($hwndCtrl, _
					  $_NULL, _
					  $_NULL, _
					  BitOR ($RDW_ERASE, $RDW_INVALIDATE))

		GUICtrlSendToDummy (GetDlgCtrlID ($hwndCtrl))
		
		NotifyParent ($lpBtnInfo, $_BN_CLICKED)
		PostMessage (GetParent ($hwndCtrl), _
					 $WM_COMMAND, _
					 MAKEWPARAM(GetDlgCtrlID ($hwndCtrl), $_BN_CLICKED), _
					 $hwndCtrl)
	EndIf

EndFunc

Func OnMouseHover ($lpBtnInfo)

	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Local $hwndCtrl = DllStructGetData ($btnInfo, "hWndCtrl")
	
	If (DllStructGetData ($btnInfo, "hBmpCurrent") == DllStructGetData ($btnInfo, "hBmpPress")) Then _
		Return
	
	If (DllStructGetData ($btnInfo, "hBmpCurrent") <> DllStructGetData ($btnInfo, "hBmpHover")) Then
		
		DllStructSetData ($btnInfo, "hBmpCurrent", DllStructGetData ($btnInfo, "hBmpHover"))
		
	RedrawWindow ($hwndCtrl, _
				  $_NULL, _
				  $_NULL, _
				  BitOR ($RDW_ERASE, $RDW_INVALIDATE))
	EndIf

EndFunc

Func OnMouseLeave ($lpBtnInfo)

	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Local $hwndCtrl = DllStructGetData ($btnInfo, "hWndCtrl")
	
	If (GetFocus ( ) == $hwndCtrl) Then _
		Return
	
	DllStructSetData ($btnInfo, "hBmpCurrent", DllStructGetData ($btnInfo, "hBmpNormal"))

	RedrawWindow ($hwndCtrl, _
				  $_NULL, _
				  $_NULL, _
				  BitOR ($RDW_ERASE, $RDW_INVALIDATE))

EndFunc

Func OnMouseMove ($lpBtnInfo)

	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Local $tme     = DllStructCreate ($TRACKMOUSEEVENT)
	
	DllStructSetData ($tme, "cbSize"     , DllStructGetSize ($tme))
	DllStructSetData ($tme, "dwFlags"    , BitOR ($_TME_HOVER, $_TME_LEAVE))
	DllStructSetData ($tme, "dwHoverTime", 10)
	DllStructSetData ($tme, "hwndTrack"  , DllStructGetData ($btnInfo, "hWndCtrl"))
	
	TrackMouseEvent (DllStructGetPtr ($tme))
	
EndFunc

Func OnPaint ($lpBtnInfo)

	Local $btnInfo  = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
    Local $ps       = DllStructCreate ($PAINTSTRUCT)
	Local $bmp      = DllStructCreate ($BITMAP)
	Local $hwndCtrl = DllStructGetData ($btnInfo, "hWndCtrl")
    Local $hdcMem, $hdc
    Local $hbmpOld, $hbmp = DllStructGetData ($btnInfo, "hbmpCurrent")
	Local $dwColor = DllStructGetData ($btnInfo, "colorText")
	Local $r = GetRValue ($dwColor)
	Local $g = GetGValue ($dwColor)
	Local $b = GetBValue ($dwColor)
	Local $hfontOld
	Local $sText

	; Get a device context for this window
	$hdc = BeginPaint ($hwndCtrl, DllStructGetPtr ($ps))
	
	; Get the private DC for the button
	$hdcMem = DllStructGetData ($btnInfo, "hdcMem")

	; Select the bitmap into the memory DC
	$hbmpOld = SelectObject ($hdcMem, $hbmp)
	
	; Get the bitmap dimensions
	GetObject ($hbmp, DllStructGetSize ($bmp), DllStructGetPtr ($bmp))
	
	; Blit the memory DC into the window DC
	StretchBlt ($hdc, 0, 0, _
				DllStructGetData ($ps, "rcPaint", 3), _
				DllStructGetData ($ps, "rcPaint", 4), _
				$hdcMem, 0, 0, _
				DllStructGetData ($bmp, "bmWidth"), _
				DllStructGetData ($bmp, "bmHeight"), _
				$SRCCOPY)
	
	; Restore the old bitmap when we have finished
	SelectObject ($hdcMem, $hbmpOld)
	
	; Set the font we are going to use
	$hfontOld = SelectObject ($hdc, DllStructGetData ($btnInfo, "hFont"))

	; Set the text colours
	SetTextColor ($hdc, RGB($r, $g, $b))
	SetBkMode ($hdc, $TRANSPARENT)

	; Find the text to draw
	GetWindowText ($hwndCtrl, $sText, 200)

	; Draw the text
	DrawText ($hdc, $sText, StringLen ($sText), _
				DllStructGetPtr ($ps, "rcPaint"), _
				BitOR ($DT_CENTER, $DT_SINGLELINE, $DT_VCENTER))

	; Restore the old font when we have finished
	SelectObject ($hdc, $hfontOld)
   
	; Release the device context
	EndPaint ($hwndCtrl, DllStructGetPtr ($ps))

EndFunc

Func OnSetFocus ($lpBtnInfo)

	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Local $hwndCtrl = DllStructGetData ($btnInfo, "hWndCtrl")

	DllStructSetData ($btnInfo, "hBmpCurrent", DllStructGetData ($btnInfo, "hBmpHover"))
	
	RedrawWindow ($hwndCtrl, _
				  $_NULL, _
				  $_NULL, _
				  BitOR ($RDW_ERASE, $RDW_INVALIDATE))
	
	PostMessage (GetParent ($hwndCtrl), _
				 $WM_COMMAND, _
				 MAKEWPARAM(GetDlgCtrlID ($hwndCtrl), $_BN_SETFOCUS), _
				 $hwndCtrl)
	
EndFunc

Func OnSetFont ($lpBtnInfo, $wParam)

	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	DllStructSetData ($btnInfo, "hFont", $wParam)

EndFunc

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                Exit Function                 ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Func OnAutoItExit ( )
	
	DllCallbackFree ($g_hButtonProc)
	
	DllClose ($gdi32dll)
	DllClose ($user32dll)
	DllClose ($shell32dll)
	DllClose ($kernel32dll)
	
EndFunc



;~~~~~~~~~~~~~~~~~~~~~~  API Functions  ~~~~~~~~~~~~~~~~~~~~~~

Func BeginPaint ($hWnd, $lpPaint)
	
	Local $aRes = DllCall ($user32dll, "hwnd", "BeginPaint", _
											"hwnd", $hWnd, _
											"ptr", $lpPaint)
	If @error Then _
		Return @error

	Return $aRes[0]
	
	
EndFunc

Func CreateCompatibleDC ($hdc)

	Local $aRes = DllCall ($gdi32dll, 'ptr', 'CreateCompatibleDC', _
									'ptr', $hdc)   ; handle to DC
	If @error Then _
		Return @error
	
	Return $aRes[0]

EndFunc

Func CreateWindowEx ($dwExStyle, $lpClassName, $lpWindowName, $dwStyle, $x, $y, $nWidth, $nHeight, $hWndParent, $hMenu, $hInstance, $lpParam)

	Local $aRes = DllCall ($user32dll, 'hwnd', 'CreateWindowEx', _
										'dword', $dwExStyle, _
										'str'  , $lpClassName, _
										'str'  , $lpWindowName, _
										'dword', $dwStyle, _
										'int'  , $x, _
										'int'  , $y, _
										'int'  , $nWidth, _
										'int'  , $nHeight, _
										'hwnd' , $hWndParent, _
										'ptr'  , $hMenu, _
										'ptr'  , $hInstance, _
										'ptr'  , $lpParam)
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func DefWindowProc ($hWnd, $nMsg, $wParam, $lParam)
	
	Local $aRes
	$aRes = DllCall ($user32dll, "int", "DefWindowProc", _
											"hwnd", $hWnd, _
											"int", $nMsg, _
											"uint", $wParam, _
											"long", $lParam)
	If @error Then _
		Return @error

	Return $aRes[0]
	
EndFunc

Func DeleteDC ($hdc)

	Local $aRes = DllCall ($gdi32dll, 'int', 'DeleteDC', _
									'ptr', $hdc)   ; handle to DC
	If @error Then _
		Return @error
	
	Return $aRes[0]

EndFunc

Func DeleteObject ($hObject)

	Local $aRes = DllCall ($gdi32dll, 'int', 'DeleteObject', _
										'ptr', $hObject)   ; handle to graphic object
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func DrawText ($hDC, $sString, $nCount, $lpRect, $uFormat)

	Local $aRes
	$aRes = DllCall ($user32dll, "int", "DrawText", _
										"ptr",  $hDC, _
										"str",  $sString, _
										"int",  $nCount, _
										"ptr",  $lpRect, _
										"uint", $uFormat)
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func EndPaint ($hWnd, $lpPaint)
	
	Local $aRes = DllCall ($user32dll, "int", "EndPaint", "hwnd", $hWnd, "ptr", $lpPaint)
	If @error Then _
		Return @error

	Return $aRes[0]
	
EndFunc

Func GetDlgCtrlID ($hwndCtl)

	Local $aRes = DllCall ($user32dll, 'int', 'GetDlgCtrlID', _
										'hwnd', $hwndCtl)
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func GetDlgItem ($hDlg, $nIDDlgItem)

	Local $aRes = DllCall ($user32dll, 'hwnd', 'GetDlgItem', _
										'hwnd', $hDlg, _
										'int' , $nIDDlgItem)
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func GetFocus ( )

	Local $aRes = DllCall ($user32dll, 'hwnd', 'GetFocus')
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func GetModuleHandle ($lpModuleName)
	
	Local $aRes = DllCall ($kernel32dll, "ptr", "GetModuleHandle", "ptr", $lpModuleName)
	If @error Then _
		Return @error

	Return $aRes[0]
	
EndFunc

Func GetObject ($hgdiobj, $cbBuffer, $lpvObject)

	Local $aRes = DllCall ($gdi32dll, 'int', 'GetObject', _
									'ptr', $hgdiobj, _  ; handle to graphics object
									'int', $cbBuffer, _     ; size of buffer for object information
									'ptr', $lpvObject)  ; buffer for object information
	If @error Then _
		Return @error
	
	Return $aRes[0]

EndFunc

Func GetParent ($hWnd)

	Local $aRes = DllCall ($user32dll, 'hwnd', 'GetParent', _
										'hwnd', $hWnd)
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func GetStockObject ($iObject)
	
	Local $aRes = DllCall ($gdi32dll, "hwnd", "GetStockObject", "int", $iObject)
	
	If @error Then _
		Return @error

	Return $aRes[0]
	
EndFunc

Func GetWindowLong ($hWnd, $nIndex)

	Local $aRes = DllCall ($user32dll, "long", "GetWindowLong", _
												"hwnd", $hWnd, _
												"int" , $nIndex)
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func GetWindowText ($hWnd, ByRef $sString, $nMaxCount)

	Local $aRes = DllCall ($user32dll, 'int', 'GetWindowText', _
										'hwnd', $hWnd, _
										'str' , $sString, _
										'int' , $nMaxCount)
	If @error Then _
		Return @error

	$sString = $aRes[2]
	Return $aRes[0]

EndFunc

Func LoadCursor ($hInstance, $sCursorName)
	
	If IsNumber ($sCursorName) Then $sCursorName = MAKEINTRESOURCE ($sCursorName)
	Local $aRes = DllCall ($user32dll, "ptr", "LoadCursor", _
										"ptr", $hInstance, _
										"str", $sCursorName)
	If @error Then _
		Return @error

	Return $aRes[0]
	
EndFunc

Func LoadIcon ($hInstance, $sIconName)
	
	If IsNumber ($sIconName) Then $sIconName = MAKEINTRESOURCE ($sIconName)
	Local $aRes = DllCall ($user32dll, "ptr", "LoadIcon", "ptr", $hInstance, "str", $sIconName)
	If @error Then _
		Return @error

	Return $aRes[0]
	
EndFunc

Func LoadImage ($hinst, $lpszName, $uType, $cxDesired, $cyDesired, $fuLoad)

	Local $aRes = DllCall ($user32dll, 'ptr', 'LoadImage', _
										'ptr' , $hinst, _
										'str' , $lpszName, _
										'uint', $uType, _
										'int' , $cxDesired, _
										'int' , $cyDesired, _
										'uint', $fuLoad)
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func PostMessage ($hWnd, $Msg, $wParam, $lParam)

	Local $aRes = DllCall ($user32dll, 'int', 'PostMessage', _
										'hwnd'  , $hWnd, _
										'uint'  , $Msg, _
										'wparam', $wParam, _
										'lparam', $lParam)
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func RedrawWindow ($hWnd, $lprcUpdate, $hrgnUpdate, $flags)

	Local $aRes = DllCall ($user32dll, 'int', 'RedrawWindow', _
										'hwnd', $hWnd, _               ; handle to window
										'ptr' , $lprcUpdate, _         ; update rectangle
										'ptr' , $hrgnUpdate, _         ; handle to update region
										'uint', $flags)                ; array of redraw flags
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func RegisterClassEx ($lpwcx)
	
	Local $aRes = DllCall ($user32dll, "dword", "RegisterClassEx", "ptr", $lpwcx)
	If @error Then _
		Return @error

	Return $aRes[0]
	
EndFunc

Func SelectObject ($hdc, $hgdiobj)

	Local $aRes = DllCall ($gdi32dll, 'ptr', 'SelectObject', _
										'ptr', $hdc, _          ; handle to DC
										'ptr', $hgdiobj)        ; handle to object
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func SendMessage ($hWnd, $Msg, $wParam, $lParam)

	Local $aRes = DllCall ($user32dll, 'ulong', 'SendMessage', _
										'hwnd'  , $hWnd, _
										'uint'  , $Msg, _
										'wparam', $wParam, _
										'lparam', $lParam)
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func SetBkMode ($hdc, $iBkMode)

	Local $aRes = DllCall ($gdi32dll, 'int', 'SetBkMode', _
										'ptr', $hdc, _      ; handle to DC
										'int', $iBkMode)    ; background mode
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func SetFocus ($hWnd)

	Local $aRes = DllCall ($user32dll, 'hwnd', 'SetFocus', _
										'hwnd', $hWnd)
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func SetTextColor ($hdc, $crColor)

	Local $aRes = DllCall ($gdi32dll, 'dword', 'SetTextColor', _
										'ptr'  , $hdc, _           ; handle to DC
										'dword', $crColor)         ; text color
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func SetWindowLong ($hWnd, $nIndex, $dwNewLong)

	Local $aRes = DllCall ($user32dll, "long", "SetWindowLong", _
												"hwnd", $hWnd, _
												"int" , $nIndex, _
												"long", $dwNewLong)
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func SetWindowText ($hWnd, $sString)
	
	Local $type = 'str'
	If (IsPtr ($sString)) Then _
		$type = 'ptr'

	Local $aRes = DllCall ($user32dll, 'int', 'SetWindowText', _
										'hwnd', $hWnd, _
										$type , $sString)
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func StretchBlt ($hdcDest, $nXOriginDest, $nYOriginDest, $nWidthDest, $nHeightDest, _
				 $hdcSrc, $nXOriginSrc, $nYOriginSrc, $nWidthSrc, $nHeightSrc, $dwRop)

	Local $aRes = DllCall ($gdi32dll, 'int', 'StretchBlt', _
										'ptr', $hdcDest, _      ; handle to destination DC
										'int', $nXOriginDest, _ ; x-coord of destination upper-left corner
										'int', $nYOriginDest, _ ; y-coord of destination upper-left corner
										'int', $nWidthDest, _   ; width of destination rectangle
										'int', $nHeightDest, _  ; height of destination rectangle
										'ptr', $hdcSrc, _       ; handle to source DC
										'int', $nXOriginSrc, _  ; x-coord of source upper-left corner
										'int', $nYOriginSrc, _  ; y-coord of source upper-left corner
										'int', $nWidthSrc, _    ; width of source rectangle
										'int', $nHeightSrc, _   ; height of source rectangle
										'dword', $dwRop)        ; raster operation code
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func TrackMouseEvent ($lpEventTrack)

	Local $aRes = DllCall ($user32dll, 'int', 'TrackMouseEvent', _
										'ptr', $lpEventTrack)
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc



;~~~~~~~~~~~~~~~~~~~~~~  Macros  ~~~~~~~~~~~~~~~~~~~~~~

Func IS_INTRESOURCE($wInteger)
	Return IsInt ($wInteger) Or StringIsDigit ($wInteger)
EndFunc

Func LOWORD($DWORD)
	Return BitAND($DWORD, 0xFFFF)
EndFunc

Func HIWORD($DWORD)
	Return BitShift($DWORD, 16)
EndFunc

Func LOBYTE($w)
	Return BitAND ( $w, 0xFF )
EndFunc

Func HIBYTE($w)
	Return BitAND ( BitShift ( $w, 8 ), 0xFF )
EndFunc

Func MAKEINTRESOURCE($lID)
	Return String ("#" & Int ($lID))
EndFunc

Func MAKELONG($wLow, $wHigh)
	Return BitOR ( BitAND ( $wLow, 0xFFFF ), BitShift (BitAND ( $wHigh, 0xFFFF ), -16) )
EndFunc

Func MAKEWPARAM($wLow, $wHigh)
	Return BitOR ( BitAND ( $wLow, 0xFFFF ), BitShift (BitAND ( $wHigh, 0xFFFF ), -16) )
EndFunc

Func RGB($r, $g, $b)
	Return BitOR ( $r, BitShift ($g, -8), BitShift ($b, -16)) ; COLORREF / BGR
EndFunc

Func GetRValue ($rgb)
	Return LOBYTE ( $rgb )
EndFunc

Func GetGValue ($rgb)
	Return LOBYTE ( BitShift ( $rgb, 8 ) )
EndFunc

Func GetBValue ($rgb)
	Return LOBYTE ( BitShift ( $rgb, 16 ) )
EndFunc















